/*
 * WebservicesWithHessianAndBurlap - Webservices with Hessian and Burlap
 * Copyright (C) 2007 Christian Schenk
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package org.christianschenk.webserviceswithhessianandburlap;

import java.net.MalformedURLException;

import org.junit.BeforeClass;
import org.junit.Ignore;
import org.mortbay.jetty.servlet.ServletHolder;
import org.mortbay.jetty.testing.ServletTester;

import com.caucho.burlap.client.BurlapProxyFactory;
import com.caucho.burlap.server.BurlapServlet;
import com.caucho.hessian.client.HessianProxyFactory;
import com.caucho.hessian.server.HessianServlet;

@Ignore
public abstract class AbstractServiceTest {

	private static ServletTester tester;
	protected static String url;

	@BeforeClass
	public static void setUpClass() throws Exception {
		tester = new ServletTester();
		url = tester.createSocketConnector(true);
		tester.setContextPath("/");
		tester.start();
	}

	@SuppressWarnings("unchecked")
	protected <A> A addServlet(final Class<?> servlet, final String path, final Class<?> service, final Class<A> api) throws MalformedURLException {
		final ServletHolder servletHolder = tester.addServlet(servlet, path);
		servletHolder.setInitParameter("service-class", service.getName());
		servletHolder.setInitParameter("api-class", api.getName());
		if (url.endsWith(path) == false) url += path;

		if (servlet.isAssignableFrom(BurlapServlet.class)) {
			return (A) new BurlapProxyFactory().create(api, url);
		} else if (servlet.isAssignableFrom(HessianServlet.class)) {
			return (A) new HessianProxyFactory().create(api, url);
		} else {
			throw new RuntimeException("Servlet must be either BurlapServlet or HessianServlet and not " + servlet.getSimpleName());
		}
	}
}